" 
"  TOPPERS Software
"      Toyohashi Open Platform for Embedded Real-Time Systems
" 
"  Copyright (C) 2011 by TAKUYA
"              Embedded and Real-Time Systems Laboratory
"              Graduate School of Information Science, Nagoya Univ., JAPAN
" 
"  上記著作権者は，以下の (1)〜(4) の条件を満たす場合に限り，本ソフトウェ
"  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改変・
"  再配布（以下，利用と呼ぶ）することを無償で許諾する．
"  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作権
"      表示，この利用条件および下記の無保証規定が，そのままの形でソース
"      コード中に含まれていること．
"  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使用
"      できる形で再配布する場合には，再配布に伴うドキュメント（利用者マ
"      ニュアルなど）に，上記の著作権表示，この利用条件および下記の無保
"      証規定を掲載すること．
"  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使用
"      できない形で再配布する場合には，次のいずれかの条件を満たすこと．
"    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著作
"        権表示，この利用条件および下記の無保証規定を掲載すること．
"    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに報
"        告すること．
"  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損害
"      からも，上記著作権者およびTOPPERSプロジェクトを免責すること．また，
"      本ソフトウェアのユーザまたはエンドユーザからのいかなる理由に基づ
"      く請求からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
" 
"  本ソフトウェアは，無保証で提供されているものである．上記著作権者およ
"  びTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的に対す
"  る適合性も含めて，いかなる保証も行わない．また，本ソフトウェアの利用
"  により直接的または間接的に生じたいかなる損害に関しても，その責任を負
"  わない．
"
"
" Vim syntax file
" Language:	cdl (Component Description Language for TECS)
" Maintainer:	TAKUYA
" Last Change:	2011 Jun 29

" Quit when a (custom) syntax file was already loaded
if exists("b:current_syntax")
  finish
endif

" synでキーワード，パターン，範囲の先頭と終わりを登録する
" msはパターンマッチの始まり，meはパターンマッチの終わり
" hsはハイライトの始まり，heはハイライトの終わり

" 括弧
syn match   cdlParen "[()]"

" コメント
syn region  cdlComment start="/\*" end="\*/"
syn region  cdlComment start="//" end="$"

" 文字列
syn region  cdlString start=+"+ skip=+\\"+ end=+"+
syn region  cdlString start=+'+ skip=+\\'+ end=+'+

" 型（汎用）
syn keyword cdlType bool_t
syn keyword cdlType char_t
syn keyword cdlType double64_t
syn keyword cdlType float32_t
syn keyword cdlType enum
syn keyword cdlType enum16
syn keyword cdlType enum32
syn keyword cdlType enum64
syn keyword cdlType enum8
syn keyword cdlType int128_t
syn keyword cdlType int16_t
syn keyword cdlType int32_t
syn keyword cdlType int64_t
syn keyword cdlType int8_t
syn keyword cdlType uint128_t
syn keyword cdlType uint16_t
syn keyword cdlType uint32_t
syn keyword cdlType uint64_t
syn keyword cdlType uint8_t
syn keyword cdlType struct
syn keyword cdlType signed
syn keyword cdlType unsigned
syn keyword cdlType void
syn keyword cdlType bool
syn keyword cdlType char
syn keyword cdlType double
syn keyword cdlType float
syn keyword cdlType int
syn keyword cdlType int128
syn keyword cdlType int16
syn keyword cdlType int32
syn keyword cdlType int64
syn keyword cdlType int8
syn keyword cdlType uint
syn keyword cdlType uint128
syn keyword cdlType uint16
syn keyword cdlType uint32
syn keyword cdlType uint64
syn keyword cdlType uint8
syn keyword cdlType intptr
syn keyword cdlType long
syn keyword cdlType short

" 型（TECS専用）
syn keyword cdlType attr
syn keyword cdlType call
syn keyword cdlType cell
syn keyword cdlType celltype
syn keyword cdlType composite
syn keyword cdlType entry
syn keyword cdlType require
syn keyword cdlType signature
syn keyword cdlType var

" factory
syn keyword cdlFactory factory contained
syn keyword cdlFactory FACTORY contained
syn match   cdlFactoryFunction "write("me=e-1 contained
syn region  cdlFactoryRegion start="\(factory\|FACTORY\)[ \t]*{" end="}" contains=cdlFactory,cdlFactoryFunction,cdlComment,cdlString,cdlParen

syn keyword cdlType C_EXP
syn keyword cdlType generate
syn keyword cdlType namespace
syn keyword cdlType region

" 指定子
syn keyword cdlSpecifier active allocator context count_is idx_is_id in in_through inline inout omit optional out out_through receive send singleton size_is string through to_through contained
syn region  cdlSpecifierRegion start="\[" end="\]" contains=cdlSpecifier,cdlParen,cdlString

" 定数
syn keyword cdlConstant false
syn keyword cdlConstant true

" マクロ，typedefなど 
syn keyword cdlMacro const
syn keyword cdlMacro typedef
syn keyword cdlMacro volatile

" プリプロセッサ
syn keyword cdlInclude import
syn keyword cdlInclude import_C

hi def link cdlComment Comment
hi def link cdlConstant Constant
hi def link cdlInclude Include
hi def link cdlMacro Macro 
hi def link cdlString String
hi def link cdlLabel Label 
hi def link cdlType Type
hi def link cdlSpecifier Label 
hi def link cdlFactory Type 
hi def link cdlFactoryFunction Label 
hi def link cdlParen SpecialChar

let b:current_syntax = "cdl"

